
require 'socket'
require 'slop'

#
#player.load('./Queen/1976 - A Day At The Races/06 - Somebody To Love.mp3')

if File.exists? './.pid'

  file = File.open('./.pid')
  puts file.read

  # now let's parse stuff

  opts = Slop.parse({:help=>true}) do # allows me to call it with --help

    banner "What do you want from Max Rebo's band?"

    on 'song', 'a song to play', :argument => true
  end

  # if ARGV is `--name Lee -v`
  if opts[:song].eql? 'stop' or opts[:song].eql? 'kill'
    TCPSocket.open('localhost', 3000).puts opts[:song]
  else
    songToPlay = Dir.glob('**/*').select { |file|
      file.include?("Queen") &&
          file.downcase.match(/(.*)\/(.*)\/(.*)/) &&
          file.downcase.match(/(.*)\/(.*)\/(.*)/).length == 4 &&
          file.downcase.match(/(.*)\/(.*)\/(.*)/)[3].include?(opts[:song].downcase)}.first

    puts "will play #{songToPlay}"

    TCPSocket.open('localhost', 3000).puts songToPlay
    #puts s.gets
  end

else

  fork do

    require 'audite'
    player = Audite.new(8192*8)

    File.open('./.pid', 'w') { |file| file.write(Process.pid) }

    server = TCPServer.new 3000

    loop do

      Thread.start(server.accept) do |client|

        recv = client.gets.strip!
        puts'received command :: ' << recv

        case recv
          when 'kill'
            puts 'triggered :: kill'
            File.delete('./.pid')
            Process.kill('INT', Process.pid)

          when 'stop'
            puts 'triggered :: stop'
            player.stop_stream

          else
            puts 'triggered :: play'
            player.load('./' << recv)
            player.start_stream
        end

        client.close
      end
    end

  end

end